unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    BtnChoose: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Timer1: TTimer;
    BtnGoto: TButton;
    BtnConnect: TButton;
    Edit3: TEdit;
    led: TPanel;
    Memo1: TMemo;
    procedure BtnChooseClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BtnGotoClick(Sender: TObject);
    procedure BtnConnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses comobj
{$IFDEF VER140}
, variants
{$ENDIF}
;

{$R *.dfm}

var T: variant;

procedure TForm1.BtnChooseClick(Sender: TObject);
var
  V: variant;
begin
  V := CreateOleObject('DriverHelper.Chooser');
  V.devicetype:='Telescope';
  edit3.text:=V.Choose(edit3.text);
  if edit3.text='' then exit;
end;

procedure TForm1.BtnConnectClick(Sender: TObject);
begin
if edit3.text='' then exit;
if not VarIsEmpty(T) then begin
  timer1.enabled:=false;
  T.connected:=false;
  T := Unassigned;
  led.Color:=clRed;
end else begin
  T := CreateOleObject(edit3.text);
  T.connected:=true;
  timer1.enabled:=true;
  led.Color:=clLime;
  memo1.clear;
  memo1.Lines.Add(T.Description);
  memo1.Lines.Add(T.DriverInfo);
end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if T.connected then begin
  edit1.text:=floattostr(T.RightAscension);
  edit2.text:=floattostr(T.declination);
end
else begin
  edit1.text:='Not connected';
  edit2.text:='';
end;
end;

procedure TForm1.BtnGotoClick(Sender: TObject);
begin
T.TargetRightAscension:=8.0;
T.TargetDeclination:=46;
T.SlewToTargetAsync;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//  if edit3.text='' then exit;
//  T := CreateOleObject(edit3.text);
end;

end.
